--- src/Fl_Scroll.cxx	2011-07-19 10:49:30.000000000 +0600
+++ src/Fl_Scroll.cxx	2014-06-29 18:38:18.341335907 +0600
@@ -402,8 +402,21 @@
 }
 
 int Fl_Scroll::handle(int event) {
-  fix_scrollbar_order();
-  return Fl_Group::handle(event);
+ fix_scrollbar_order();
+ // NOTE (kdiman) if we have the cursor of mouse over hor scrollbar - then we will scroll it by mouse wheel scrolling:
+ if (event == FL_MOUSEWHEEL &&
+  Fl::belowmouse() == &hscrollbar &&
+  hscrollbar.visible()) {
+  int value = Fl::event_dy()<0?-hscrollbar.linesize():hscrollbar.linesize();
+ value += int(hscrollbar.value());
+ int min = int(hscrollbar.minimum());
+ int max = int(hscrollbar.maximum());
+ if (Fl::event_dy() < 0 && value < min) { value = min; }
+ if (Fl::event_dy() > 0 && value > max) { value = max; }
+ hscrollbar.value(value);
+ hscrollbar.do_callback();
+ return 0;
+  } else { return Fl_Group::handle(event); }
 }
 
 //
